/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

public class LayerType {
	static public final int
		ltBinder = 0,
		ltCoverRect = 1,
		ltOpaque = 1, // the same as ltCoverRect
		ltTransparent = 2, // alpha blend
		ltAlpha = 2, // the same as ltTransparent
		ltAdditive = 3,
		ltSubtractive = 4,
		ltMultiplicative = 5,
		ltEffect = 6,
		ltFilter = 7,
		ltDodge = 8,
		ltDarken = 9,
		ltLighten = 10,
		ltScreen = 11,
		ltAddAlpha = 12, // additive alpha blend
		ltPsNormal = 13,
		ltPsAdditive = 14,
		ltPsSubtractive = 15,
		ltPsMultiplicative = 16,
		ltPsScreen = 17,
		ltPsOverlay = 18,
		ltPsHardLight = 19,
		ltPsSoftLight = 20,
		ltPsColorDodge = 21,
		ltPsColorDodge5 = 22,
		ltPsColorBurn = 23,
		ltPsLighten = 24,
		ltPsDarken = 25,
		ltPsDifference = 26,
		ltPsDifference5 = 27,
		ltPsExclusion = 28;

	static public final int
		omPsNormal = ltPsNormal,
		omPsAdditive = ltPsAdditive,
		omPsSubtractive = ltPsSubtractive,
		omPsMultiplicative = ltPsMultiplicative,
		omPsScreen = ltPsScreen,
		omPsOverlay = ltPsOverlay,
		omPsHardLight = ltPsHardLight,
		omPsSoftLight = ltPsSoftLight,
		omPsColorDodge = ltPsColorDodge,
		omPsColorDodge5 = ltPsColorDodge5,
		omPsColorBurn = ltPsColorBurn,
		omPsLighten = ltPsLighten,
		omPsDarken = ltPsDarken,
		omPsDifference = ltPsDifference,
		omPsDifference5 = ltPsDifference5,
		omPsExclusion = ltPsExclusion,
		omAdditive = ltAdditive,
		omSubtractive = ltSubtractive,
		omMultiplicative = ltMultiplicative,
		omDodge = ltDodge,
		omDarken = ltDarken,
		omLighten = ltLighten,
		omScreen = ltScreen,
		omAlpha = ltTransparent,
		omAddAlpha = ltAddAlpha,
		omOpaque = ltCoverRect,

		omAuto = 128;	// operation mode is guessed from the source layer type

	static public final int
		/** primal method; nearest neighbor method */
		stNearest = 0,
		/** fast linear interpolation (does not have so much precision) */
		stFastLinear = 1,
		/** (strict) linear interpolation */
		stLinear = 2,
		/** cubic interpolation */
		stCubic = 3,

		/** stretch type mask */
		stTypeMask = 0xf,
		/** flag mask */
		stFlagMask = 0xf0,

		/** referencing source is not limited by the given rectangle
		 * (may allow to see the border pixel to interpolate) */
		stRefNoClip = 0x10;

	static final public boolean isTypeUsingAlpha( int type ) {
		return
			type == ltAlpha				||
			type == ltPsNormal			||
			type == ltPsAdditive		||
			type == ltPsSubtractive		||
			type == ltPsMultiplicative	||
			type == ltPsScreen			||
			type == ltPsOverlay			||
			type == ltPsHardLight		||
			type == ltPsSoftLight		||
			type == ltPsColorDodge		||
			type == ltPsColorDodge5		||
			type == ltPsColorBurn		||
			type == ltPsLighten			||
			type == ltPsDarken			||
			type == ltPsDifference		||
			type == ltPsDifference5		||
			type == ltPsExclusion		;
	}

	static final public boolean isTypeUsingAddAlpha( int  type ) {
		return type == ltAddAlpha;
	}

	static final public boolean isTypeUsingAlphaChannel( int type ) {
		return isTypeUsingAddAlpha(type) || isTypeUsingAlpha(type);
	}
}
