/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import jp.kirikiri.tjs2.Error;
import jp.kirikiri.tjs2.Dispatch2;
import jp.kirikiri.tjs2.Holder;
import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tjs2.Variant;
import jp.kirikiri.tjs2.VariantClosure;

public class SimpleOptionProviderObject implements SimpleOptionProvider {

	private VariantClosure mObject;
	//private String mString;
	private Variant mRetVariant;

	public SimpleOptionProviderObject( VariantClosure object ) {
		mObject = object;
		mRetVariant = new Variant();
	}
	@Override
	public int getAsNumber(String name, long[] value) {
		try {
			mRetVariant.clear();
			int er = mObject.propGet( 0, name, mRetVariant, null );
			if( er < 0 ) return er;

			if( mRetVariant.isVoid() ) return Error.E_MEMBERNOTFOUND;

			if( value != null ) value[0] = mRetVariant.asInteger();
			mRetVariant.clear();

			return Error.S_OK;
		} catch( TJSException e ) {
			return Error.E_FAIL;
		}
	}

	@Override
	public int getAsString(String name, String[] out) {
		try {
			mRetVariant.clear();
			int er = mObject.propGet( 0, name, mRetVariant, null );
			if( er < 0 ) return er;

			if( mRetVariant.isVoid() ) return Error.E_MEMBERNOTFOUND;

			if( out != null ) out[0] = mRetVariant.asString();
			mRetVariant.clear();

			return Error.S_OK;
		} catch( TJSException e ) {
			return Error.E_FAIL;
		}
	}

	@Override
	public int getValue(String name, Variant dest) {
		try {
			if( dest == null ) return Error.E_FAIL;
			int er = mObject.propGet( 0, name, dest, null );
			if( er < 0 ) return er;
			return Error.S_OK;
		} catch( TJSException e ) {
			return Error.E_FAIL;
		}
	}

	@Override
	public int getDispatchObject(Holder<Dispatch2> dsp) {
		if( dsp != null ) dsp.mValue = mObject.mObjThis;
		return Error.S_OK;
	}

}
