/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import jp.kirikiri.tjs2.TJSException;

public interface TransHandlerProvider {

	/** transition using only one(self) layer ( eg. simple fading ) */
	public static final int ttSimple = 0;
	/** transition using two layer ( eg. cross fading ) */
	public static final int ttExchange = 1;


	/**
	 * used when the transition processing is region-divisible and
	 * the transition updates entire area of the layer.
	 * update area is always given by TransHandler.process caller.
	 * handler must use only given area of the source bitmap on each
	 * callbacking.
	 */
	public static final int tutDivisibleFade = 0;
	/**
	 * same as tutDivisibleFade, except for its usage of source area.
	 * handler can use any area of the source bitmap.
	 * this will somewhat slower than tutDivisibleFade.
	 */
	public static final int tutDivisible = 1;
	/**
	 * used when the transition processing is not region-divisible or
	 * the transition updates only some small regions rather than entire
	 * area.
	 * update area is given by callee of TransHandler.process,
	 * via LayerUpdater interface.
	 */
	public static final int tutGiveUpdate = 2;

	/**
	 * return this transition name
	 * @return
	 */
	public String getName();

	/**
	 * start transition and return a handler.
	 * "handler" is an object of iTVPDivisibleTransHandler when
	 * updatetype is tutDivisibleFade or tutDivisible.
	 * Otherwise is an object of iTVPGiveUpdateTransHandler ( cast to
	 * each class to use it )
	 * layertype is the destination layer type.
	 * @param options : option provider
	 * @param imagepro : image provider
	 * @param layertype : destination layer type
	 * @param src1w : source 1 width
	 * @param src1h : source 1 height
	 * @param src2w : source 2 width
	 * @param src2h : source 2 height
	 * @param type : [0]transition type, [1]update typwe
	 * @return  transition handler
	 * @throws TJSException
	 */
	public BaseTransHandler startTransition( SimpleOptionProvider options, SimpleImageProvider imagepro,
			int layertype, int src1w, int src1h, int src2w, int src2h, int[] type ) throws TJSException;
}
