/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import java.util.ArrayList;

import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tvp2.TVP;

public class WindowList {
	public ArrayList<WindowNI> mWindowVector;

	public WindowList() {
		mWindowVector = new ArrayList<WindowNI>();
	}
	public void registerWindowToList( WindowNI window ) {
		if(TVP.MainWindow == null && mWindowVector.size() == 0) {
			// first time the window is registered
			TVP.MainWindow = window; // set as main window
		}
		mWindowVector.add(window);

		// notify that the layer must lost capture state
		final int count = mWindowVector.size();
		for( int i = 0; i < count; i++ ) {
			WindowNI ni = mWindowVector.get(i);
			ni.postReleaseCaptureEvent();
		}
	}

	public void unregisterWindowToList( WindowNI window ) {
		final int count = mWindowVector.size();
		for( int i = 0; i < count; i++ ) {
			WindowNI ni = mWindowVector.get(i);
			if( ni == window ) {
				boolean flag = false;
				if( ni == TVP.MainWindow ) flag = true;
				mWindowVector.remove(i);
				if( flag ) {
					TVP.mainWindowClose(); // MainWindow had been closed
					TVP.MainWindow = null;
				}
				break;
			}
		}
	}

	public WindowNI getWindowListAt( int idx ) { return mWindowVector.get(idx); }

	public int getWindowCount() { return mWindowVector.size(); }

	public void clearAllWindowInputEvents() {
		final int count = mWindowVector.size();
		for( int i = 0; i < count; i++ ) {
			WindowNI ni = mWindowVector.get(i);
			ni.clearInputEvents();
		}
	}

	public void deliverDrawDeviceShow() throws TJSException {
		final int count = mWindowVector.size();
		for( int i = 0; i < count; i++ ) {
			WindowNI ni = mWindowVector.get(i);
			ni.deliverDrawDeviceShow();
		}
	}
}
